"use strict";
exports.__esModule = true;
var Is = /** @class */ (function () {
    function Is() {
    }
    Is.callToString = function (arg) {
        return Object.prototype.toString.call(arg);
    };
    ;
    Is.$string = function (arg) {
        return Is.callToString(arg) === '[object String]';
    };
    ;
    Is.is = function (arg, type) {
        var response = false;
        if (Is.$string(type))
            response = Is.callToString(arg) === "[object " + type + "]";
        else if (Is.$function(type))
            response = arg instanceof type;
        return response;
    };
    ;
    Is.$array = function (arg) {
        return Is.is(arg, 'Array');
    };
    ;
    Is.$null = function (arg) {
        return Is.is(arg, 'Null');
    };
    ;
    Is.$number = function (arg) {
        return Is.is(arg, 'Number');
    };
    ;
    Is.$object = function (arg) {
        return Is.is(arg, 'Object');
    };
    ;
    Is.$undefined = function (arg) {
        return Is.is(arg, 'Undefined');
    };
    ;
    Is.$boolean = function (arg) {
        return Is.is(arg, 'Boolean');
    };
    ;
    Is.$function = function (arg) {
        return Is.callToString(arg) === '[object Function]';
    };
    ;
    Is.objectIsValid = function (data, rules) {
        if (!Is.$object(data))
            throw new Error('The data parameter must be an Object');
        if (!Is.$object(rules))
            throw new Error('The rules parameter must be an Object');
        var $response = true;
        var $keys = Object.getOwnPropertyNames(rules);
        $keys.forEach(function (key) {
            var rule = rules[key];
            if (Is.$array(rule)) {
                if (rule.length < 1)
                    return;
                var parcial_1 = false;
                rule.forEach(function (_rule) {
                    parcial_1 = parcial_1 || Is.is(data[key], _rule);
                });
                return $response = $response && parcial_1;
            }
            $response = $response && Is.is(data[key], rule);
        });
        return $response;
    };
    return Is;
}());
exports["default"] = Is;
